// Class E_Series

function E_Series ( message_hander ) {

   this.message_hander = message_hander;
   this.unit           = '';

   var C_E1             = [ 1 ];
   var C_E3             = [ 1, 2.2, 4.7, 10 ];
   var C_E6             = [ 1.0, 1.5, 2.2, 3.3, 4.7, 6.8, 10 ];
   var C_E12            = [ 1.0, 1.2, 1.5, 1.8, 2.2, 2.7, 3.3, 3.9, 4.7, 5.6, 6.8, 8.2, 10 ];
   var C_E24            = [ 1.0, 1.1, 1.2, 1.3, 1.5, 1.6, 1.8, 2.0, 2.2, 2.4, 2.7, 3.0,
                            3.3, 3.6, 3.9, 4.3, 4.7, 5.1, 5.6, 6.2, 6.8, 7.5, 8.2, 9.1, 10
                          ];
   var C_E96            = [ 1.00, 1.02, 1.05, 1.07, 1.10, 1.13, 1.15, 1.18, 1.21, 1.24, 1.27, 1.30,
                            1.33, 1.37, 1.40, 1.43, 1.47, 1.50, 1.54, 1.58, 1.62, 1.65, 1.69, 1.74,
                            1.78, 1.82, 1.87, 1.91, 1.96, 2.00, 2.05, 2.10, 2.15, 2.21, 2.26, 2.32,
                            2.37, 2.43, 2.49, 2.55, 2.61, 2.67, 2.74, 2.80, 2.87, 2.94, 3.01, 3.09,
                            3.16, 3.24, 3.32, 3.40, 3.48, 3.57, 3.65, 3.74, 3.83, 3.92, 4.02, 4.12,
                            4.22, 4.32, 4.42, 4.53, 4.64, 4.75, 4.87, 4.99, 5.11, 5.23, 5.36, 5.49,
                            5.62, 5.76, 5.90, 6.04, 6.19, 6.34, 6.49, 6.65, 6.81, 6.98, 7.15, 7.32,
                            7.50, 7.68, 7.87, 8.06, 8.25, 8.45, 8.66, 8.87, 9.09, 9.31, 9.53, 9.76, 10
                          ];

   this.last_unit = function() {
      return this.unit;
   }; // this.last_unit

   this.real = function ( real_value, unit, field ) {

      var value = real_value.toString();

      if ( value === null ) return '';
      if ( value ==  '' )   return '';

      if ( unit ) {
         if ( Array.isArray( unit ) ) {
            var units_length = unit.length;
            for (i=0; i<units_length; i++ ) {
               if ( value.endsWith( unit[i] ) ) {
                  value = value.substr( 0, value.length - unit[i].length );
                  this.unit = unit[i];
                  break;
               };
            };
         } else if ( value.endsWith( unit ) ) {
            value = value.substr( 0, value.length - unit.length );
            this.unit = unit;
         };
      } else {
         this.unit = '';
      };

      value = value.replace( ',', '.' );

      if        ( value.endsWith('p') ) {
         value = value.substr( 0, value.length -1 );
         value = value * 1e-12;
      } else if ( value.endsWith('n') ) {
         value = value.substr( 0, value.length -1 );
         value = value * 1e-9;
      } else if ( value.endsWith('µ') ) {
         value = value.substr( 0, value.length -1 );
         value = value * 1e-6;
      } else if ( value.endsWith('m') ) {
         value = value.substr( 0, value.length -1 );
         value = value * 1e-3;
      } else if ( value.endsWith('k') ) {
         value = value.substr( 0, value.length -1 );
         value = value * 1e+3;
      } else if ( value.endsWith('M') ) {
         value = value.substr( 0, value.length -1 );
         value = value * 1e+6;
      } else if ( value.endsWith('G') ) {
         value = value.substr( 0, value.length -1 );
         value = value * 1e+9;
      } else {
         value = 1 * value;
      };

      if ( isNaN(value) || value <=0 ) {
         this.message_hander.put_error( "Der Wert " + field + " = '" + real_value + "' ist nicht erlaubt." );
      };
      return value;

   }; // real

   this.Ing = function ( value, unit ) {

      if ( value === null ) return null;
      if ( value == ''    ) return '';
      if ( unit == null   ) unit = '';
      if ( value == 0     ) return value + unit;
      if ( isNaN(value)   ) return '';

      var abs_value = Math.abs( value );
      if ( abs_value < 1e-9 ) {
         var my_value = value*1e12;
         return my_value.toFixed( 2 ) + 'p' + unit;
      } else if ( abs_value < 1e-6 ) {
         var my_value = value*1e9;
         return my_value.toFixed( 2 ) + 'n' + unit;
      } else if ( abs_value < 1e-3 ) {
         var my_value = value*1e6;
         return my_value.toFixed( 2 ) + 'µ' + unit;
      } else if ( abs_value < 1 ) {
         var my_value = value*1e3;
         return my_value.toFixed( 2 ) + 'm' + unit;
      } else if ( abs_value > 1e+9 ) {
         var my_value = value/1e9;
         return my_value.toFixed( 2 ) + 'G' + unit;
      } else if ( abs_value > 1e+6 ) {
         var my_value = value/1e6;
         return my_value.toFixed( 2 ) + 'M' + unit;
      } else if ( abs_value > 1e+3 ) {
         var my_value = value/1e+3
         return my_value.toFixed( 2 ) + 'k' + unit;
      } else {
         var my_value = Number(value);
         return my_value.toFixed( 2 ) + unit;
      };

   }; // Ing

   this.E_multiplyer = function ( series ) {
      if ( series == 'E3' ) {
         return C_E3[1];
      } else if ( series == 'E6' ) {
         return C_E6[1];
      } else if ( series == 'E12' ) {
         return C_E12[1];
      } else if ( series == 'E24' ) {
         return C_E24[1];
      } else if ( series == 'E96' ) {
         return C_E96[1];
      } else {
         return 1.01;
      };
   }; // E_multiplyer

   this.E_value = function ( value, series ) {
      if ( series == 'E1' ) {
         return 1;
      } else if ( series == 'E3' ) {
         return this.E_get_value( value, C_E3 );
      } else if ( series == 'E6' ) {
         return this.E_get_value( value, C_E6 );
      } else if ( series == 'E12' ) {
         return this.E_get_value( value, C_E12 );
      } else if ( series == 'E24' ) {
         return this.E_get_value( value, C_E24 );
      } else if ( series == 'E96' ) {
         return this.E_get_value( value, C_E96 );
      } else {
         return value;
      };
   }; // E_value

   this.stringify = function ( value, series, unit ) {

      if ( value === null ) return null;
      if ( value == ''    ) return '';

      if ( series == 'Ing' ) {
         return this.Ing( value, unit );
      } else if ( series == 'E1' ) {
         return this.Ex( value, C_E1, unit );
      } else if ( series == 'E3' ) {
         return this.Ex( value, C_E3, unit );
      } else if ( series == 'E6' ) {
         return this.Ex( value, C_E6, unit );
      } else if ( series == 'E12' ) {
         return this.Ex( value, C_E12, unit );
      } else if ( series == 'E24' ) {
         return this.Ex( value, C_E24, unit );
      } else if ( series == 'E96' ) {
         return this.Ex( value, C_E96, unit );
      } else if ( unit == null ) {
         return value;
      } else {
         return value + unit;
      };

   } // stringify

   this.E_get_value = function ( value, series_list ) {

      if ( value === null ) return null;
      if ( value == 0     ) return value;

      var log   = Math.log( value ) / Math.LN10;
      var power = Math.pow( 10, Math.floor( log ) );
      var scale = value / power;
      var diff  = 10;
      var use   = NaN;

      for ( var i=0; i<series_list.length; i++ ) {
         if ( Math.abs( scale - series_list[i] ) < diff ) {
            use  = series_list[i];
            diff = Math.abs( scale - series_list[i] );
         };
      };

      if ( isNaN(use) ) {
         this.message_hander.put_error( "Der Wert " + value + " kann nicht in eine E-Serie gewandelt werden.\n" );
         return null;
      };

      return use * power;

   }; // E_get_value

   this.Ex = function ( value, series_list, unit ) {

      if ( value === null ) return null;
      if ( value == 0     ) return this.Ing( value, unit );
      var e_value = this.E_get_value( value, series_list );

      if ( e_value === null ) return null;

      return this.Ing( e_value, unit );

   }; // Ex

   this.E1 = function ( value, unit ) {
      return this.Ex( value, C_E1, unit );
   }; // E1

   this.E3 = function ( value, unit ) {
      return this.Ex( value, C_E3, unit );
   }; // E3

   this.E6 = function ( value, unit ) {
      return this.Ex( value, C_E6, unit );
   }; // E6

   this.E12 = function ( value, unit ) {
      return this.Ex( value, C_E12, unit );
   }; // E12

   this.E24 = function ( value, unit ) {
      return this.Ex( value, C_E24, unit );
   }; // E24

   this.E96 = function ( value, unit ) {
      return this.Ex( value, C_E96, unit );
   }; // E96

}; // E_Series
