
var My_Messages  = new TinyMessage( "Note" );
var My_Series    = new E_Series( My_Messages );
var E6           = new SimpleLabel( "LabelE6" );
var E12          = new SimpleLabel( "LabelE12" );
var E24          = new SimpleLabel( "LabelE24" );
var E96          = new SimpleLabel( "LabelE96" );

function calculate_E( Series, E, value, initial ) {

   var W         = My_Series.stringify( value, Series, '' );
   var my_V      = My_Series.real( value, ['Ω', 'F', 'H', 'V' ], '' );
   var my_W      = My_Series.real( W,     ['Ω', 'F', 'H', 'V' ], '' );
   var deviation = 100 * ( my_W - my_V ) / my_V;
   if ( Math.abs(deviation) < 0.01 ) deviation = 0;

   var Dev = "<br> Der Wert weicht um " + deviation.toFixed( 2 ) + "% von " + initial + " ab."
   var Unit = My_Series.last_unit();
   E.put( '<b>' + Series + ": " + W + Unit + '</b> ' + Dev );

   return;

}; // calculate_E

function do_B1_e1( form, series ) {

   My_Messages.reset();
   E6.reset();
   E12.reset();
   E24.reset();
   E96.reset();

   var V = form.W.value;

   if ( !V ) {
      My_Messages.put_error( "Bitte einen Wert > 0 eingeben." );
      return;
   } else if ( V < 0 ) {
      My_Messages.put_error( "Bitte einen Wert > 0 eingeben." );
      return;
   };
   
   var W = My_Series.real( V, ['Ω', 'F', 'H', 'V' ], '' );
   if ( My_Messages.error() ) return;

   calculate_E( 'E6',  E6,  W, V );
   calculate_E( 'E12', E12, W, V );
   calculate_E( 'E24', E24, W, V );
   calculate_E( 'E96', E96, W, V );

   return;

} // do_B1_e1

function do_B1_c1( form, series ) {

   form.W.value = '';
   My_Messages.reset();
   E6.reset();
   E12.reset();
   E24.reset();
   E96.reset();

   return;

}; // do_B1_c1
