
var My_Messages       = new TinyMessage( "Note" );
var My_Series         = new E_Series( My_Messages );
var My_Deviation      = new SimpleLabel( "LabelAbweichung" );

var LED_voltage       = new SimpleLabel( 'LEDSpannung' );
var LED_total_voltage = new SimpleLabel( 'Gesamtspannung' );

var LED_voltages      = {
                          rot:    1.8,
                          Rot:    1.8,
                          gruen:  2.2,
                          Gruen:  2.2,
                          grün:   2.2,
                          Grün:   2.2,
                          gelb:   2.0,
                          Gelb:   2.0,
                          blau:   3.0,
                          Blau:   3.0,
                          weiss:  3.0,
                          Weiss:  3.0,
                          weis:   3.0,
                          Weiß:   3.0,
                          orange: 2.0,
                          Orange: 2.0
                        };

var U_reserve     = 1.1;

var LED_Voltage_1 = 1.8;
var LED_Voltage   = 1.8;
var LED_number    = 1;

function LED_init_me () {
   document.form1.R1[0].checked=true;
   document.form1.R2[0].checked=true;
   LED_Voltage_1 = 1.8;
   LED_Voltage   = 1.8;
   LED_number    = 1;
   LED_voltage.put( LED_Voltage_1.toFixed( 1 ) + 'V ' );
   LED_total_voltage.put( LED_Voltage.toFixed( 1 ) + 'V ' );
   return;
}; // LED_init_me

function set_deviation ( form ) {
   var U       = My_Series.real( form.U.value, 'V', 'U' );
   var R       = My_Series.real( form.R.value, 'Ω', 'R' );
   var I       = My_Series.real( form.I.value, 'A', 'I' );
   if ( My_Messages.error() || !U || !R  ) {
      My_Deviation.reset();
      return;
   };
   var I_value = (U-LED_Voltage)/R
   var deviation     = 100 * ( I - I_value ) / I_value;
   if ( Math.abs(deviation) < 0.1 ) deviation = 0;
   My_Deviation.put( "Der berechnete Wert R weicht um " + deviation.toFixed( 2 ) + "% ab." );
   return;
}; // set_deviation

function do_R1_rot( form, color ) {
   My_Messages.reset();
   My_Deviation.reset();
   var selected_color = color.value;
   LED_Voltage_1      = LED_voltages[selected_color];
   LED_Voltage        = LED_number * LED_Voltage_1;
   LED_voltage.put( LED_Voltage_1.toFixed( 1 ) + 'V ' );
   LED_total_voltage.put( LED_Voltage.toFixed( 1 ) + 'V ' );
   return;
}; // do_R1_rot

function do_R1_gruen( form, color ) {
   do_R1_rot( form, color );
   return;
}; // do_R1_gruen

function do_R1_gelb( form, color ) {
   do_R1_rot( form, color );
   return;
}; // do_R1_gelb

function do_R1_blau( form, color ) {
   do_R1_rot( form, color );
   return;
}; // do_R1_blau

function do_R1_weiss( form, color ) {
   do_R1_rot( form, color );
   return;
}; // do_R1_weiss

function do_R2_w1( form, number ) {
   My_Messages.reset();
   My_Deviation.reset();
   LED_number         = number.value;
   LED_Voltage        = LED_number * LED_Voltage_1;
   LED_total_voltage.put( LED_Voltage.toFixed( 1 ) + 'V ' );
   return;
}; // do_R2_w1

function do_R2_w2( form, number ) {
   do_R2_w1( form, number );
   return;
}; // do_R2_w2

function do_R2_w3( form, number ) {
   do_R2_w1( form, number );
   return;
}; // do_R2_w3

function do_R2_w4( form, number ) {
   do_R2_w1( form, number );
   return;
}; // do_R2_w4

function do_R2_w5( form, number ) {
   do_R2_w1( form, number );
   return;
}; // do_R2_w5

function do_R2_w6( form, number ) {
   do_R2_w1( form, number );
   return;
}; // do_R2_w6

function do_R2_w7( form, number ) {
   do_R2_w1( form, number );
   return;
}; // do_R2_w7

function do_R2_w8( form, number ) {
   do_R2_w1( form, number );
   return;
}; // do_R2_w8

function do_R2_w9( form, number ) {
   do_R2_w1( form, number );
   return;
}; // do_R2_w9

function do_R2_w10( form, number ) {
   do_R2_w1( form, number );
   return;
}; // do_R2_w10

function do_R2_w11( form, number ) {
   do_R2_w1( form, number );
   return;
}; // do_R2_w11

function do_R2_w12( form, number ) {
   do_R2_w1( form, number );
   return;
}; // do_R2_w12

function do_B3_volt( form, series ) {
   My_Messages.reset();
   My_Deviation.reset();
   var I    = My_Series.real( form.I.value, 'A', 'I' );
   var R    = My_Series.real( form.R.value, 'Ω', 'R' );
   var PLED = My_Series.real( form.PLED.value, 'W', 'PLED' );
   if ( My_Messages.error() ) return;
   if ( R && I ) {
      form.U.value = My_Series.stringify( (I*R)+LED_Voltage, series.value, 'V' );
      My_Messages.put( "U = (I * R) + ULEDges" );
      form.P.value    = '';
      form.PLED.value = '';
   } else if ( R && PLED ) {
      form.U.value = My_Series.stringify( R*PLED/LED_Voltage + LED_Voltage, series.value, 'V' );
      My_Messages.put( "U = R * PLED/ULEDges + ULEDges" );
      form.I.value = '';
      form.P.value = '';
   } else {
      My_Messages.put_error( "Es werden I und R oder PLED und R erwartet." );
   };
   return;
} // do_B3_volt

function do_B3_clear ( form ) {
   My_Messages.reset();
   My_Deviation.reset();
   form.U.value = '';
}; // do_B3_clear

function do_B4_ampere( form, series ) {
   My_Messages.reset();
   My_Deviation.reset();
   var U    = My_Series.real( form.U.value, 'V', 'U' );
   var R    = My_Series.real( form.R.value, 'Ω', 'R' );
   var PLED = My_Series.real( form.PLED.value, 'W', 'PLED' );
   if ( My_Messages.error() ) return;
   if ( R && U ) {
      if ( U < (LED_Voltage * U_reserve) ) {
         My_Messages.put_error( "Die Spannung U ist zu klein für die LED-Gesamtspannung." );
         return;
      };
      form.I.value = My_Series.stringify( (U-LED_Voltage)/R, series.value, 'A' );
      My_Messages.put( "I = ( U - ULEDges ) / R" );
      form.P.value    = '';
      form.PLED.value = '';
   } else if ( PLED ) {
      form.I.value = My_Series.stringify( PLED/LED_Voltage, series.value, 'A' );
      My_Messages.put( "I = PLED/ULEDges" );
      form.R.value = '';
      form.P.value = '';
   } else {
      My_Messages.put_error( "Es werden entweder U und R oder PLED erwartet." );
   };
   return;
} // do_B4_ampere

function do_B4_clear ( form ) {
   My_Messages.reset();
   My_Deviation.reset();
   form.I.value = '';
}; // do_B4_clear

function do_B5_ohm( form, series ) {
   My_Messages.reset();
   My_Deviation.reset();
   var U    = My_Series.real( form.U.value, 'V', 'U' );
   var I    = My_Series.real( form.I.value, 'A', 'I' );
   var PLED = My_Series.real( form.PLED.value, 'W', 'PLED' );
   if ( My_Messages.error() ) return;
   if ( I && U ) {
      if ( U < (LED_Voltage * U_reserve) ) {
         My_Messages.put_error( "Die Spannung U ist zu klein für die LED-Gesamtspannung." );
         return;
      };
      form.R.value = My_Series.stringify( (U-LED_Voltage)/I, series.value, 'Ω' );
      My_Messages.put( "R = ( U - ULEDges ) / I" );
      set_deviation( form );
      form.P.value    = '';
      form.PLED.value = '';
   } else if ( U && PLED ) {
      if ( U < (LED_Voltage * U_reserve) ) {
         My_Messages.put_error( "Die Spannung U ist zu klein für die LED-Gesamtspannung." );
         return;
      };
      form.R.value = My_Series.stringify( ((U-LED_Voltage)*LED_Voltage)/PLED, series.value, 'Ω' );
      My_Messages.put( "R = ( (U - ULEDges) * ULEDges ) / PLED" );
      set_deviation( form );
      form.I.value = '';
      form.P.value = '';
   } else {
      My_Messages.put_error( "Es werden entweder U und I oder I und PLED erwartet." );
   };
   return;
} // do_B5_ohm

function do_B5_clear ( form ) {
   My_Messages.reset();
   My_Deviation.reset();
   form.R.value = '';
}; // do_B5_clear

function do_B6_leistung( form, series ) {
   My_Messages.reset();
   My_Deviation.reset();
   var I    = My_Series.real( form.I.value, 'A', 'I' );
   var U    = My_Series.real( form.U.value, 'V', 'U' );
   var R    = My_Series.real( form.R.value, 'Ω', 'R' );
   if ( My_Messages.error() ) return;
   if ( I && U ) {
      form.P.value = My_Series.stringify( ( U - LED_Voltage ) * I, series.value, 'W' );
      My_Messages.put( "P = ( U - ULEDges ) * I" );
   } else if ( U && R ) {
      form.P.value = My_Series.stringify( ( (U - LED_Voltage) * (U - LED_Voltage) ) / R, series.value, 'W' );
      My_Messages.put( "P = ( U - ULEDges )² / R" );
   } else if ( I && R ) {
      form.P.value = My_Series.stringify( I*I * R, series.value, 'W' );
      My_Messages.put( "P = I² * R" );
   } else {
      My_Messages.put_error( "Es werden zwei der Werte U, I oder R erwartet." );
   };
   return;
} // do_B6_leistung

function do_B6_clear ( form ) {
   My_Messages.reset();
   My_Deviation.reset();
   form.P.value = '';
}; // do_B6_clear

function do_B7_leistung( form, series ) {
   My_Messages.reset();
   My_Deviation.reset();
   var I = My_Series.real( form.I.value, 'A', 'I' );
   if ( My_Messages.error() ) return;
   if ( I ) {
      form.PLED.value = My_Series.stringify( I * LED_Voltage, series.value, 'W' );
      My_Messages.put( "PLEDges = I * ULEDges" );
   } else {
      My_Messages.put_error( "Es wird I erwartet." );
   };
   return;
} // do_B7_leistung

function do_B7_clear ( form ) {
   My_Messages.reset();
   My_Deviation.reset();
   form.PLED.value = '';
}; // do_B7_clear

function do_R3_exakt ( form, series ) {
   U = My_Series.real( form.U.value, 'V', 'U' );
   form.U.value = My_Series.stringify( U, 'Exakt', 'V' );
   return;
}; // do_R3_exakt

function do_R3_ing ( form, series ) {
   var U = My_Series.real( form.U.value, 'V', 'U' );
   form.U.value = My_Series.stringify( U, 'Ing', 'V' );
}; // do_R3_ing

function do_R4_exakt ( form, series ) {
   var I = My_Series.real( form.I.value, 'A', 'I' );
   form.I.value = My_Series.stringify( I, 'Exakt', 'A' );
   set_deviation( form );
}; // do_R4_exakt

function do_R4_ing ( form, series ) {
   var I = My_Series.real( form.I.value, 'A', 'I' );
   form.I.value = My_Series.stringify( I, 'Ing', 'A' );
   set_deviation( form );
}; // do_R4_ing

function do_R5_exakt ( form, series ) {
   var R = My_Series.real( form.R.value, 'Ω', 'R' );
   form.R.value = My_Series.stringify( R, 'Exakt', 'Ω' );
   set_deviation( form );
}; // do_R5_exakt

function do_R5_ing ( form, series ) {
   var R = My_Series.real( form.R.value, 'Ω', 'R' );
   form.R.value = My_Series.stringify( R, 'Ing', 'Ω' );
   set_deviation( form );
}; // do_R5_ing

function do_R5_e6 ( form, series ) {
   var R = My_Series.real( form.R.value, 'Ω', 'R' );
   form.R.value = My_Series.stringify( R, 'E6', 'Ω' );
   set_deviation( form );
}; // do_R5_e6

function do_R5_e12 ( form, series ) {
   var R = My_Series.real( form.R.value, 'Ω', 'R' );
   form.R.value = My_Series.stringify( R, 'E12', 'Ω' );
   set_deviation( form );
}; // do_R5_e12

function do_R5_e24 ( form, series ) {
   var R = My_Series.real( form.R.value, 'Ω', 'R' );
   form.R.value = My_Series.stringify( R, 'E24', 'Ω' );
   set_deviation( form );
}; // do_R5_e24

function do_R6_exakt ( form, series ) {
   var P = My_Series.real( form.P.value, 'W', 'P' );
   form.P.value = My_Series.stringify( P, 'Exakt', 'W' );
}; // do_R6_exakt

function do_R6_ing ( form, series ) {
   var P = My_Series.real( form.P.value, 'W', 'P' );
   form.P.value = My_Series.stringify( P, 'Ing', 'W' );
}; // do_R6_ing

function do_R7_exakt ( form, series ) {
   var P = My_Series.real( form.PLED.value, 'W', 'P' );
   form.PLED.value = My_Series.stringify( P, 'Exakt', 'W' );
}; // do_R7_exakt

function do_R7_ing ( form, series ) {
   var P = My_Series.real( form.PLED.value, 'W', 'P' );
   form.PLED.value = My_Series.stringify( P, 'Ing', 'W' );
}; // do_R7_ing

