
var My_Messages  = new TinyMessage( "Note" );
var My_Series    = new E_Series( My_Messages );
var My_Deviation = new SimpleLabel( "LabelAbweichung" );

function set_deviation ( form, current ) {
   var U = My_Series.real( form.U.value, 'V', 'U' );
   var R = My_Series.real( form.R.value, 'Ω', 'R' );
   var I = My_Series.real( form.I.value, 'A', 'I' );
   if ( My_Messages.error() ) {
      My_Deviation.reset();
      return;
   };

   if ( current && !U && !I ) {
      var current_value = My_Series.real( current, 'Ω', 'R' );
      var deviation = 100 * ( R - current_value ) / current_value;
      if ( Math.abs(deviation) < 0.1 ) deviation = 0;
      My_Deviation.put( "Der berechnete Wert R weicht um " + deviation.toFixed( 2 ) + "% von " + current + " ab." );
      return;
   }; 

   if ( !U || !R  ) {
      My_Deviation.reset();
      return;
   };
   var I_value   = U/R
   var deviation = 100 * ( I - I_value ) / I_value;
   if ( Math.abs(deviation) < 0.1 ) deviation = 0;
   My_Deviation.put( "Der berechnete Wert R weicht um " + deviation.toFixed( 2 ) + "% ab." );
   return;
}; // set_deviation

function do_B1_volt1( form, series ) {
   My_Messages.reset();
   My_Deviation.reset();
   var I = My_Series.real( form.I.value, 'A', 'I' );
   var R = My_Series.real( form.R.value, 'Ω', 'R' );
   var P = My_Series.real( form.P.value, 'W', 'P' );
   if ( My_Messages.error() ) return;
   if ( (!I && !R && !P) ) {
      My_Messages.put_error( "Es werden zwei der Werte I>0, R>0 oder P>0 benötigt." );
   } else if ( R && I ) {
      form.U.value = My_Series.stringify( I*R, series.value, 'V' );
      My_Messages.put( "U = I * R" );
      if ( P ) My_Messages.put( "P wurde ignoriert" );
   } else if ( I && P ) {
      form.U.value = My_Series.stringify( P/I, series.value, 'V' );
      My_Messages.put( "U = P / I" );
   } else if ( R && P ) {
      form.U.value = My_Series.stringify( Math.sqrt( P*R ), series.value, 'V' );
      My_Messages.put( "U = sqrt( P * R )" );
   } else {
      My_Messages.put_error( "Es werden zwei der Werte I>0, R>0 oder P>0 benötigt." );
   };
   return;
} // do_B1_volt1

function do_B1_clear1 ( form ) {
   My_Messages.reset();
   My_Deviation.reset();
   form.U.value = '';
}; // do_B1_clear1

function do_B2_ampere2( form, series ) {
   My_Messages.reset();
   My_Deviation.reset();
   var U = My_Series.real( form.U.value, 'V', 'U' );
   var R = My_Series.real( form.R.value, 'Ω', 'R' );
   var P = My_Series.real( form.P.value, 'W', 'P' );
   if ( My_Messages.error() ) return;
   if ( (!U && !R && !P) ) {
      My_Messages.put_error( "Es werden zwei der Werte U>0, R>0 oder P>0 benötigt." );
   } else if ( R && U ) {
      form.I.value = My_Series.stringify( U/R, series.value, 'A' );
      My_Messages.put( "I = U / R" );
      if ( P ) My_Messages.put( "P wurde ignoriert" );
   } else if ( U && P ) {
      form.I.value = My_Series.stringify( P/U, series.value, 'A' );
      My_Messages.put( "I = P / U" );
   } else if ( R && P ) {
      form.I.value = My_Series.stringify( Math.sqrt( P/R ), series.value, 'A' );
      My_Messages.put( "I = sqrt( P / R )" );
   } else {
      My_Messages.put_error( "Es werden zwei der Werte U>0, R>0 oder P>0 benötigt." );
   };
   return;
} // do_B2_ampere2

function do_B2_clear2 ( form ) {
   My_Messages.reset();
   My_Deviation.reset();
   form.I.value = '';
}; // do_B1_clear1

function do_B3_ohm3( form, series ) {
   My_Messages.reset();
   My_Deviation.reset();
   var U = My_Series.real( form.U.value, 'V', 'U' );
   var I = My_Series.real( form.I.value, 'A', 'I' );
   var P = My_Series.real( form.P.value, 'W', 'P' );
   if ( My_Messages.error() ) return;
   if ( (!U && !I && !P) ) {
      My_Messages.put_error( "Es werden zwei der Werte U>0, I>0 oder P>0 benötigt." );
   } else if ( I && U ) {
      form.R.value = My_Series.stringify( U/I, series.value, 'Ω' );
      My_Messages.put( "R = U / I" );
      if ( P ) My_Messages.put( "P wurde ignoriert" );
      set_deviation( form );
   } else if ( U && P ) {
      form.R.value = My_Series.stringify( U**2/P, series.value, 'Ω' );
      My_Messages.put( "R = U**2 / P" );
      set_deviation( form );
   } else if ( I && P ) {
      form.R.value = My_Series.stringify( P/R**2, series.value, 'Ω' );
      My_Messages.put( "R = P / I**2" );
      set_deviation( form );
   } else {
      My_Messages.put_error( "Es werden zwei der Werte U>0, I>0 oder P>0 benötigt." );
   };
   return;
} // do_B3_ohm3

function do_B3_clear3 ( form ) {
   My_Messages.reset();
   My_Deviation.reset();
   form.R.value = '';
}; // do_B3_clear3

function do_B4_leistung4( form, series ) {
   My_Messages.reset();
   My_Deviation.reset();
   var I = My_Series.real( form.I.value, 'A', 'I' );
   var U = My_Series.real( form.U.value, 'V', 'U' );
   var R = My_Series.real( form.R.value, 'Ω', 'R' );
   if ( My_Messages.error() ) return;
   if ( (!I && !U && !R) ) {
      My_Messages.put_error( "Es werden zwei der Werte U>0, I>0 oder R>0 benötigt." );
   } else if ( I && U ) {
      form.P.value = My_Series.stringify( U*I, series.value, 'W' );
      My_Messages.put( "P = U * I" );
      if ( R ) My_Messages.put( "R wurde ignoriert" );
   } else if ( U && R ) {
      form.P.value = My_Series.stringify( U**2 / R, series.value, 'W' );
      My_Messages.put( "P = U**2 / R" );
   } else if ( I && R ) {
      form.P.value = My_Series.stringify( I**2 * R, series.value, 'W' );
      My_Messages.put( "P = I**2 * R" );
   } else {
      My_Messages.put_error( "Es werden zwei der Werte U>0, I>0 oder R>0 benötigt." );
   };
   return;
} // do_B4_leistung4

function do_B4_clear4 ( form ) {
   My_Messages.reset();
   My_Deviation.reset();
   form.P.value = '';
}; // do_B4_clear4

function do_R1_exakt ( form, series ) {
   U = My_Series.real( form.U.value, 'V', 'U' );
   form.U.value = My_Series.stringify( U, 'Exakt', 'V' );
   return;
}; // do_R1_exakt

function do_R1_ing ( form, series ) {
   U = My_Series.real( form.U.value, 'V', 'U' );
   form.U.value = My_Series.stringify( U, 'Ing', 'V' );
}; // do_R1_ing

function do_R2_exakt ( form, series ) {
   I = My_Series.real( form.I.value, 'A', 'I' );
   form.I.value = My_Series.stringify( I, 'Exakt', 'A' );
}; // do_R2_exakt

function do_R2_ing ( form, series ) {
   I = My_Series.real( form.I.value, 'A', 'I' );
   form.I.value = My_Series.stringify( I, 'Ing', 'A' );
}; // do_R2_ing

function do_R3_exakt ( form, series ) {
   R = My_Series.real( form.R.value, 'Ω', 'R' );
   form.R.value = My_Series.stringify( R, 'Exakt', 'Ω' );
}; // do_R3_exakt

function do_R3_ing ( form, series ) {
   R = My_Series.real( form.R.value, 'Ω', 'R' );
   form.R.value = My_Series.stringify( R, 'Ing', 'Ω' );
}; // do_R3_ing

function do_R3_e6 ( form, series ) {
   var current = form.R.value;
   var R       = My_Series.real( form.R.value, 'Ω', 'R' );
   form.R.value = My_Series.stringify( R, 'E6', 'Ω' );
   set_deviation( form, current );
}; // do_R3_e6

function do_R3_e12 ( form, series ) {
   var current = form.R.value;
   var R       = My_Series.real( form.R.value, 'Ω', 'R' );
   form.R.value = My_Series.stringify( R, 'E12', 'Ω' );
   set_deviation( form, current );
}; // do_R3_e12

function do_R3_e24 ( form, series ) {
   var current = form.R.value;
   var R       = My_Series.real( form.R.value, 'Ω', 'R' );
   form.R.value = My_Series.stringify( R, 'E24', 'Ω' );
   set_deviation( form, current );
}; // do_R3_e24

function do_R3_e96 ( form, series ) {
   var current = form.R.value;
   var R       = My_Series.real( form.R.value, 'Ω', 'R' );
   form.R.value = My_Series.stringify( R, 'E96', 'Ω' );
   set_deviation( form, current );
}; // do_R3_e96

function do_R4_exakt ( form, series ) {
   P = My_Series.real( form.P.value, 'W', 'P' );
   form.P.value = My_Series.stringify( P, 'Exakt', 'W' );
}; // do_R4_exakt

function do_R4_ing ( form, series ) {
   P = My_Series.real( form.P.value, 'W', 'P' );
   form.P.value = My_Series.stringify( P, 'Ing', 'W' );
}; // do_R4_ing

